﻿Option Explicit On

' Translation between 10 Languages, Any Language and Esperanto
'
' MP Nov / Dez 2011: Program 3.0
' MP Nov / Dez 2011: Word Search
' MP Aug / Sep 2012: Vocabulary List


Public Class FDictionary

    Private Sub Dictionary_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Texte von Labels and Buttons
        frmDictionary.GroupBoxSingleWord.Text = "Word Search"
        frmDictionary.ComboBoxTo.Text = "Please select!"
        frmDictionary.LabelFrom.Text = "from"
        frmDictionary.LabelTo.Text = "to"
        frmDictionary.LabelWord.Text = "Word"
        frmDictionary.LabelTranslation.Text = "Translation"
        frmDictionary.GroupBoxMode.Text = "Search Mode"
        frmDictionary.RadioButtonStrict.Text = "Strict"
        frmDictionary.RadioButtonStart.Text = "Starts with"
        frmDictionary.ButtonSearch.Text = "Search"
        frmDictionary.GroupBoxWordList.Text = "Vocabulary List"
        frmDictionary.ComboBoxTo2.Text = "Please select!"
        frmDictionary.LabelFrom2.Text = "from"
        frmDictionary.LabelTo2.Text = "to"
        frmDictionary.GroupBoxCriterion.Text = "Selection Criterion"
        frmDictionary.RadioButtonNiveau.Text = "Niveau"
        frmDictionary.RadioButtonTheme.Text = "Theme"
        frmDictionary.ButtonList.Text = "List"

        ' Suchmodus
        frmDictionary.RadioButtonStrict.Checked = True

        ' Listenkriterium
        frmDictionary.RadioButtonTheme.Checked = True

        ' Sprachen-Auswahl from
        frmDictionary.ComboBoxFrom.Items.Clear()
        frmDictionary.ComboBoxFrom.Items.Add("Esperanto")
        frmDictionary.ComboBoxFrom.Items.Add("Deutsch")
        frmDictionary.ComboBoxFrom.Items.Add("English")
        frmDictionary.ComboBoxFrom.Items.Add("Français")
        frmDictionary.ComboBoxFrom.Items.Add("Español")
        frmDictionary.ComboBoxFrom.Items.Add("Italiano")
        frmDictionary.ComboBoxFrom.Items.Add("Português")
        frmDictionary.ComboBoxFrom.Items.Add("Dansk")
        frmDictionary.ComboBoxFrom.Items.Add("Ελληνικά")
        frmDictionary.ComboBoxFrom.Items.Add("Русский")
        frmDictionary.ComboBoxFrom.Items.Add("Polski")
        frmDictionary.ComboBoxFrom.Items.Add("Any Language")
        frmDictionary.ComboBoxFrom.SelectedIndex = pubFromLanguage

        ' Sprachen-Auswahl to
        frmDictionary.ComboBoxTo.Items.Clear()
        frmDictionary.ComboBoxTo.Items.Add("Esperanto")
        frmDictionary.ComboBoxTo.Items.Add("Deutsch")
        frmDictionary.ComboBoxTo.Items.Add("English")
        frmDictionary.ComboBoxTo.Items.Add("Français")
        frmDictionary.ComboBoxTo.Items.Add("Español")
        frmDictionary.ComboBoxTo.Items.Add("Italiano")
        frmDictionary.ComboBoxTo.Items.Add("Português")
        frmDictionary.ComboBoxTo.Items.Add("Dansk")
        frmDictionary.ComboBoxTo.Items.Add("Ελληνικά")
        frmDictionary.ComboBoxTo.Items.Add("Русский")
        frmDictionary.ComboBoxTo.Items.Add("Polski")
        frmDictionary.ComboBoxTo.Items.Add("Any Language")
        frmDictionary.ComboBoxTo.SelectedIndex = -1

        ' Sprachen-Auswahl from2
        frmDictionary.ComboBoxFrom2.Items.Clear()
        frmDictionary.ComboBoxFrom2.Items.Add("Esperanto")
        frmDictionary.ComboBoxFrom2.Items.Add("Deutsch")
        frmDictionary.ComboBoxFrom2.Items.Add("English")
        frmDictionary.ComboBoxFrom2.Items.Add("Français")
        frmDictionary.ComboBoxFrom2.Items.Add("Español")
        frmDictionary.ComboBoxFrom2.Items.Add("Italiano")
        frmDictionary.ComboBoxFrom2.Items.Add("Português")
        frmDictionary.ComboBoxFrom2.Items.Add("Dansk")
        frmDictionary.ComboBoxFrom2.Items.Add("Ελληνικά")
        frmDictionary.ComboBoxFrom2.Items.Add("Русский")
        frmDictionary.ComboBoxFrom2.Items.Add("Polski")
        frmDictionary.ComboBoxFrom2.Items.Add("Any Language")
        frmDictionary.ComboBoxFrom2.SelectedIndex = pubFromLanguage

        ' Sprachen-Auswahl to2
        frmDictionary.ComboBoxTo2.Items.Clear()
        frmDictionary.ComboBoxTo2.Items.Add("Esperanto")
        frmDictionary.ComboBoxTo2.Items.Add("Deutsch")
        frmDictionary.ComboBoxTo2.Items.Add("English")
        frmDictionary.ComboBoxTo2.Items.Add("Français")
        frmDictionary.ComboBoxTo2.Items.Add("Español")
        frmDictionary.ComboBoxTo2.Items.Add("Italiano")
        frmDictionary.ComboBoxTo2.Items.Add("Português")
        frmDictionary.ComboBoxTo2.Items.Add("Dansk")
        frmDictionary.ComboBoxTo2.Items.Add("Ελληνικά")
        frmDictionary.ComboBoxTo2.Items.Add("Русский")
        frmDictionary.ComboBoxTo2.Items.Add("Polski")
        frmDictionary.ComboBoxTo2.Items.Add("Any Language")
        frmDictionary.ComboBoxTo2.SelectedIndex = -1

    End Sub

    ' Word Search (1st Function)

    Private Sub ButtonSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSearch.Click
        ' Search
        Dim searchWord As String
        Dim searchMode As Integer
        Dim fromLanguage As Integer
        Dim toLanguage As Integer
        Dim i As Integer

        ' Suchbegriff
        searchWord = TextBoxWord.Text

        ' Suchmodus
        searchMode = 0
        If (frmDictionary.RadioButtonStrict.Checked = True) Then
            searchMode = 0
        ElseIf (frmDictionary.RadioButtonStart.Checked = True) Then
            If (searchWord.Length >= 3) Then
                searchMode = 1
            Else
                searchMode = 0
                RichTextBoxTranslation.Text = "Option needs at least 3 letters!"
            End If
        End If

        ' Indices
        fromLanguage = frmDictionary.ComboBoxFrom.SelectedIndex
        toLanguage = frmDictionary.ComboBoxTo.SelectedIndex

        ' check
        If (searchWord = "") Then
            MsgBox("Please enter Search Term!", MsgBoxStyle.Information, "Missing Choice")
            Exit Sub
        End If
        If (toLanguage = -1) Then
            MsgBox("Please select to which Language!", MsgBoxStyle.Information, "Missing Choice")
            Exit Sub
        End If

        ' Suche
        If (fromLanguage = LangName.Esperanto) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._EspPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._EspPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._EspNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._EspNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._EspVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._EspVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._EspAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._EspAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._EspAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._EspAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._EspPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._EspPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._EspParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._EspParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._EspJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._EspJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Deutsch) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._GerPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._GerPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._GerNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._GerNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._GerVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._GerVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._GerAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._GerAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._GerAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._GerAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._GerPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._GerPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._GerParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._GerParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._GerJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._GerJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.English) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._EngPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._EngPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._EngNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._EngNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._EngVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._EngVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._EngAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._EngAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._EngAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._EngAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._EngPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._EngPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._EngParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._EngParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._EngJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._EngJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Francais) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._FraPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._FraPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._FraNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._FraNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._FraVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._FraVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._FraAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._FraAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._FraAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._FraAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._FraPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._FraPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._FraParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._FraParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._FraJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._FraJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Espanol) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._SpaPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._SpaPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._SpaNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._SpaNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._SpaVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._SpaVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._SpaAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._SpaAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._SpaAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._SpaAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._SpaPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._SpaPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._SpaParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._SpaParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._SpaJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._SpaJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Italiano) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._ItaPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._ItaPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._ItaNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._ItaNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._ItaVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._ItaVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._ItaAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._ItaAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._ItaAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._ItaAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._ItaPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._ItaPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._ItaParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._ItaParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._ItaJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._ItaJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Portoguese) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._PorPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._PorPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._PorNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._PorNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._PorVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._PorVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._PorAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._PorAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._PorAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._PorAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._PorPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._PorPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._PorParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._PorParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._PorJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._PorJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Dansk) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._DanPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._DanPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._DanNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._DanNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._DanVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._DanVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._DanAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._DanAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._DanAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._DanAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._DanPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._DanPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._DanParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._DanParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._DanJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._DanJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Ellenika) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._GrePronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._GrePronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._GreNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._GreNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._GreVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._GreVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._GreAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._GreAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._GreAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._GreAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._GrePreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._GrePreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._GreParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._GreParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._GreJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._GreJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Russkij) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._RusPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._RusPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._RusNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._RusNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._RusVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._RusVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._RusAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._RusAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._RusAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._RusAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._RusPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._RusPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._RusParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._RusParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._RusJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._RusJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.Polski) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._PolPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._PolPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._PolNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._PolNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._PolVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._PolVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._PolAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._PolAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._PolAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._PolAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._PolPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._PolPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._PolParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._PolParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._PolJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._PolJunction, toLanguage)
                End If
            Next

        ElseIf (fromLanguage = LangName.AnyLang) Then
            For i = 1 To countVocPronomen
                If (testEntry(searchMode, pubVocabularyPro(i)._AnyPronomen, searchWord) = True) Then
                    report("Pro", i, pubVocabularyPro(i)._AnyPronomen, toLanguage)
                End If
            Next
            For i = 1 To countVocNomen
                If (testEntry(searchMode, pubVocabularyNom(i)._AnyNomen, searchWord) = True) Then
                    report("Nom", i, pubVocabularyNom(i)._AnyNomen, toLanguage)
                End If
            Next
            For i = 1 To countVocVerb
                If (testEntry(searchMode, pubVocabularyVer(i)._AnyVerb, searchWord) = True) Then
                    report("Ver", i, pubVocabularyVer(i)._AnyVerb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdverb
                If (testEntry(searchMode, pubVocabularyAdv(i)._AnyAdverb, searchWord) = True) Then
                    report("Adv", i, pubVocabularyAdv(i)._AnyAdverb, toLanguage)
                End If
            Next
            For i = 1 To countVocAdjective
                If (testEntry(searchMode, pubVocabularyAdj(i)._AnyAdjective, searchWord) = True) Then
                    report("Adj", i, pubVocabularyAdj(i)._AnyAdjective, toLanguage)
                End If
            Next
            For i = 1 To countVocPreposition
                If (testEntry(searchMode, pubVocabularyPre(i)._AnyPreposition, searchWord) = True) Then
                    report("Pre", i, pubVocabularyPre(i)._AnyPreposition, toLanguage)
                End If
            Next
            For i = 1 To countVocParticle
                If (testEntry(searchMode, pubVocabularyPar(i)._AnyParticle, searchWord) = True) Then
                    report("Par", i, pubVocabularyPar(i)._AnyParticle, toLanguage)
                End If
            Next
            For i = 1 To countVocJunction
                If (testEntry(searchMode, pubVocabularyJun(i)._AnyJunction, searchWord) = True) Then
                    report("Jun", i, pubVocabularyJun(i)._AnyJunction, toLanguage)
                End If
            Next

        Else
            ' error

        End If

        ' check
        If (RichTextBoxTranslation.Text = "") Then
            RichTextBoxTranslation.Text = "No entry!"
        End If

    End Sub

    Private Function testEntry(ByVal searchMode As Integer, ByVal searchEntry As String, ByVal searchWord As String) As Boolean
        ' Test

        If (searchMode = 0 And searchEntry = searchWord Or searchMode = 1 And searchEntry.StartsWith(searchWord) = True) Then
            testEntry = True
        Else
            testEntry = False
        End If

    End Function

    Private Sub report(ByVal wordtype As String, ByVal wordIndex As Integer, ByVal searchEntry As String, ByVal toLanguage As Integer)
        ' Report
        Dim context As String
        Dim synomym As String
        Dim translation As String

        If (wordtype = "Pro") Then
            ' Pronomen
            context = pubVocabularyPro(wordIndex)._KonPronomen
            synomym = pubVocabularyPro(wordIndex)._SynPronomen
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyPro(wordIndex)._EspPronomen

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyPro(wordIndex)._GerPronomen

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyPro(wordIndex)._EngPronomen

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyPro(wordIndex)._FraPronomen

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyPro(wordIndex)._SpaPronomen

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyPro(wordIndex)._ItaPronomen

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyPro(wordIndex)._PorPronomen

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyPro(wordIndex)._DanPronomen

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyPro(wordIndex)._GrePronomen

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyPro(wordIndex)._RusPronomen

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyPro(wordIndex)._PolPronomen

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyPro(wordIndex)._AnyPronomen

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Pro] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Nom") Then
            ' Nomen
            context = pubVocabularyNom(wordIndex)._KonNomen
            synomym = pubVocabularyNom(wordIndex)._SynNomen
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyNom(wordIndex)._EspNomen

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyNom(wordIndex)._GerNomen

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyNom(wordIndex)._EngNomen

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyNom(wordIndex)._FraNomen

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyNom(wordIndex)._SpaNomen

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyNom(wordIndex)._ItaNomen

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyNom(wordIndex)._PorNomen

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyNom(wordIndex)._DanNomen

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyNom(wordIndex)._GreNomen

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyNom(wordIndex)._RusNomen

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyNom(wordIndex)._PolNomen

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyNom(wordIndex)._AnyNomen

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Nom] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Ver") Then
            ' Verb
            context = pubVocabularyVer(wordIndex)._KonVerb
            synomym = pubVocabularyVer(wordIndex)._SynVerb
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyVer(wordIndex)._EspVerb

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyVer(wordIndex)._GerVerb

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyVer(wordIndex)._EngVerb

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyVer(wordIndex)._FraVerb

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyVer(wordIndex)._SpaVerb

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyVer(wordIndex)._ItaVerb

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyVer(wordIndex)._PorVerb

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyVer(wordIndex)._DanVerb

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyVer(wordIndex)._GreVerb

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyVer(wordIndex)._RusVerb

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyVer(wordIndex)._PolVerb

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyVer(wordIndex)._AnyVerb

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Ver] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Adv") Then
            ' Adverb
            context = pubVocabularyAdv(wordIndex)._KonAdverb
            synomym = pubVocabularyAdv(wordIndex)._SynAdverb
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyAdv(wordIndex)._EspAdverb

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyAdv(wordIndex)._GerAdverb

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyAdv(wordIndex)._EngAdverb

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyAdv(wordIndex)._FraAdverb

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyAdv(wordIndex)._SpaAdverb

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyAdv(wordIndex)._ItaAdverb

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyAdv(wordIndex)._PorAdverb

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyAdv(wordIndex)._DanAdverb

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyAdv(wordIndex)._GreAdverb

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyAdv(wordIndex)._RusAdverb

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyAdv(wordIndex)._PolAdverb

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyAdv(wordIndex)._AnyAdverb

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Adv] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Adj") Then
            ' Adjektiv
            context = pubVocabularyAdj(wordIndex)._KonAdjective
            synomym = pubVocabularyAdj(wordIndex)._SynAdjective
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyAdj(wordIndex)._EspAdjective

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyAdj(wordIndex)._GerAdjective

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyAdj(wordIndex)._EngAdjective

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyAdj(wordIndex)._FraAdjective

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyAdj(wordIndex)._SpaAdjective

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyAdj(wordIndex)._ItaAdjective

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyAdj(wordIndex)._PorAdjective

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyAdj(wordIndex)._DanAdjective

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyAdj(wordIndex)._GreAdjective

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyAdj(wordIndex)._RusAdjective

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyAdj(wordIndex)._PolAdjective

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyAdj(wordIndex)._AnyAdjective

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Adj] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Pre") Then
            ' Preposition
            context = pubVocabularyPre(wordIndex)._KonPreposition
            synomym = pubVocabularyPre(wordIndex)._SynPreposition
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyPre(wordIndex)._EspPreposition

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyPre(wordIndex)._GerPreposition

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyPre(wordIndex)._EngPreposition

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyPre(wordIndex)._FraPreposition

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyPre(wordIndex)._SpaPreposition

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyPre(wordIndex)._ItaPreposition

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyPre(wordIndex)._PorPreposition

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyPre(wordIndex)._DanPreposition

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyPre(wordIndex)._GrePreposition

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyPre(wordIndex)._RusPreposition

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyPre(wordIndex)._PolPreposition

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyPre(wordIndex)._AnyPreposition

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Pre] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Par") Then
            ' Particle
            context = pubVocabularyPar(wordIndex)._KonParticle
            synomym = pubVocabularyPar(wordIndex)._SynParticle
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyPar(wordIndex)._EspParticle

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyPar(wordIndex)._GerParticle

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyPar(wordIndex)._EngParticle

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyPar(wordIndex)._FraParticle

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyPar(wordIndex)._SpaParticle

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyPar(wordIndex)._ItaParticle

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyPar(wordIndex)._PorParticle

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyPar(wordIndex)._DanParticle

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyPar(wordIndex)._GreParticle

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyPar(wordIndex)._RusParticle

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyPar(wordIndex)._PolParticle

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyPar(wordIndex)._AnyParticle

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Par] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        ElseIf (wordtype = "Jun") Then
            ' Junktion
            context = pubVocabularyJun(wordIndex)._KonJunction
            synomym = pubVocabularyJun(wordIndex)._SynJunction
            translation = ""
            If (toLanguage = LangName.Esperanto) Then
                translation = pubVocabularyJun(wordIndex)._EspJunction

            ElseIf (toLanguage = LangName.Deutsch) Then
                translation = pubVocabularyJun(wordIndex)._GerJunction

            ElseIf (toLanguage = LangName.English) Then
                translation = pubVocabularyJun(wordIndex)._EngJunction

            ElseIf (toLanguage = LangName.Francais) Then
                translation = pubVocabularyJun(wordIndex)._FraJunction

            ElseIf (toLanguage = LangName.Espanol) Then
                translation = pubVocabularyJun(wordIndex)._SpaJunction

            ElseIf (toLanguage = LangName.Italiano) Then
                translation = pubVocabularyJun(wordIndex)._ItaJunction

            ElseIf (toLanguage = LangName.Portoguese) Then
                translation = pubVocabularyJun(wordIndex)._PorJunction

            ElseIf (toLanguage = LangName.Dansk) Then
                translation = pubVocabularyJun(wordIndex)._DanJunction

            ElseIf (toLanguage = LangName.Ellenika) Then
                translation = pubVocabularyJun(wordIndex)._GreJunction

            ElseIf (toLanguage = LangName.Russkij) Then
                translation = pubVocabularyJun(wordIndex)._RusJunction

            ElseIf (toLanguage = LangName.Polski) Then
                translation = pubVocabularyJun(wordIndex)._PolJunction

            ElseIf (toLanguage = LangName.AnyLang) Then
                translation = pubVocabularyJun(wordIndex)._AnyJunction

            Else
                ' error

            End If

            ' Anzeige
            If (translation <> "" And translation <> "***" And translation <> "###") Then
                RichTextBoxTranslation.Text = RichTextBoxTranslation.Text & vbCrLf & "[Jun] " & translation & vbCrLf & "   [got] " & searchEntry & vbCrLf & "   [con] " & context & vbCrLf & "   [syn] " & synomym
            End If

        Else
            ' error

        End If

        ' check
        If (RichTextBoxTranslation.Text = "") Then
            RichTextBoxTranslation.Text = "Empty entry!"
        End If

    End Sub

    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        ' Close Window
        Close()

    End Sub

    Private Sub ComboBoxFrom_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxFrom.SelectedIndexChanged
        ' Clear Input
        TextBoxWord.Text = ""
        ' Clear Output
        RichTextBoxTranslation.Text = ""

    End Sub

    Private Sub ComboBoxTo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTo.SelectedIndexChanged
        ' Clear Output
        RichTextBoxTranslation.Text = ""

    End Sub

    Private Sub TextBoxWord_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxWord.TextChanged
        ' Clear Output
        RichTextBoxTranslation.Text = ""

    End Sub

    Private Sub TextBoxWord_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxWord.KeyUp
        ' Set Focus
        If (e.KeyValue = Keys.Return) Then
            ButtonSearch.Focus()
        End If

    End Sub

    Private Sub RadioButtonStrict_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonStrict.CheckedChanged
        ' Clear Output
        RichTextBoxTranslation.Text = ""
    End Sub

    Private Sub RadioButtonStart_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonStart.CheckedChanged
        ' Clear Output
        RichTextBoxTranslation.Text = ""
    End Sub

    ' Vocabulary List (2nd Function)

    Private Sub RadioButtonNiveau_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonNiveau.CheckedChanged
        ' Choice: Niveau
        frmDictionary.ComboBoxSortChoice.Items.Clear()
        frmDictionary.ComboBoxSortChoice.Items.Add("A1")
        frmDictionary.ComboBoxSortChoice.Items.Add("A2")
        frmDictionary.ComboBoxSortChoice.Items.Add("B1")
        frmDictionary.ComboBoxSortChoice.Items.Add("B2")
        frmDictionary.ComboBoxSortChoice.Text = "Please Select!"

    End Sub

    Private Sub RadioButtonTheme_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonTheme.CheckedChanged
        ' Choice: Theme
        Dim i As Integer

        frmDictionary.ComboBoxSortChoice.Items.Clear()
        For i = 1 To pubVocThemes(0)
            frmDictionary.ComboBoxSortChoice.Items.Add(pubVocThemes(i))
        Next
        frmDictionary.ComboBoxSortChoice.Text = "Please Select!"

    End Sub

    Private Sub ButtonList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonList.Click
        ' Generate Vocabulary List
        Dim Datum As Date
        Dim Zeit As Date
        Dim tmpWordListEle As New WordListElement
        Dim wordListVoc As New List(Of WordListElement)
        Dim vocListFile As String
        Dim languages(2) As String
        Dim fromLanguage As Integer
        Dim toLanguage As Integer
        Dim selIndex As String
        Dim selString As String
        Dim nivString As String
        Dim thmString As String
        Dim fromString As String
        Dim toString As String
        Dim conString As String
        Dim synString As String
        Dim tmpString As String
        Dim strDatum As String
        Dim strZeit As String
        Dim wordlstcount As Integer
        Dim i As Integer


        ' File Name
        vocListFile = "VocabularyList.htm"

        ' Indices
        fromLanguage = frmDictionary.ComboBoxFrom2.SelectedIndex
        toLanguage = frmDictionary.ComboBoxTo2.SelectedIndex
        selIndex = frmDictionary.ComboBoxSortChoice.SelectedIndex

        ' check
        If (toLanguage = -1) Then
            MsgBox("Please select to which Language!", MsgBoxStyle.Information, "Missing Choice")
            Exit Sub
        End If
        If (selIndex = -1) Then
            MsgBox("Please select which Selection!", MsgBoxStyle.Information, "Missing Choice")
            Exit Sub
        End If
        
        ' Selection String
        languages(1) = fromLanguage
        languages(2) = toLanguage
        selString = ""
        If (frmDictionary.RadioButtonNiveau.Checked = True) Then
            selString = frmDictionary.ComboBoxSortChoice.Items(selIndex).ToString
        ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
            selString = selIndex.ToString + 1
        End If

        ' Make Selection

        ' Pronomen
        For i = 1 To countVocPronomen
            nivString = pubVocabularyPro(i)._NivPronomen
            thmString = Val(pubVocabularyPro(i)._ThmPronomen).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyPro(i)._EspPronomen
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyPro(i)._GerPronomen
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyPro(i)._EngPronomen
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyPro(i)._FraPronomen
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyPro(i)._SpaPronomen
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyPro(i)._ItaPronomen
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyPro(i)._DanPronomen
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyPro(i)._PorPronomen
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyPro(i)._GrePronomen
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyPro(i)._RusPronomen
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyPro(i)._PolPronomen
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyPro(i)._AnyPronomen
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyPro(i)._KonPronomen
                synString = pubVocabularyPro(i)._SynPronomen
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Pronoun"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Nomen
        For i = 1 To countVocNomen
            nivString = pubVocabularyNom(i)._NivNomen
            thmString = Val(pubVocabularyNom(i)._ThmNomen).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyNom(i)._EspNomen
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyNom(i)._GerNomen
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyNom(i)._EngNomen
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyNom(i)._FraNomen
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyNom(i)._SpaNomen
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyNom(i)._ItaNomen
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyNom(i)._DanNomen
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyNom(i)._PorNomen
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyNom(i)._GreNomen
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyNom(i)._RusNomen
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyNom(i)._PolNomen
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyNom(i)._AnyNomen
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyNom(i)._KonNomen
                synString = pubVocabularyNom(i)._SynNomen
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Noun"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Verben
        For i = 1 To countVocVerb
            nivString = pubVocabularyVer(i)._NivVerb
            thmString = Val(pubVocabularyVer(i)._ThmVerb).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyVer(i)._EspVerb
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyVer(i)._GerVerb
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyVer(i)._EngVerb
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyVer(i)._FraVerb
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyVer(i)._SpaVerb
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyVer(i)._ItaVerb
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyVer(i)._DanVerb
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyVer(i)._PorVerb
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyVer(i)._GreVerb
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyVer(i)._RusVerb
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyVer(i)._PolVerb
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyVer(i)._AnyVerb
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyVer(i)._KonVerb
                synString = pubVocabularyVer(i)._SynVerb
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Verb"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Adverben
        For i = 1 To countVocAdverb
            nivString = pubVocabularyAdv(i)._NivAdverb
            thmString = Val(pubVocabularyAdv(i)._ThmAdverb).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyAdv(i)._EspAdverb
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyAdv(i)._GerAdverb
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyAdv(i)._EngAdverb
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyAdv(i)._FraAdverb
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyAdv(i)._SpaAdverb
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyAdv(i)._ItaAdverb
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyAdv(i)._DanAdverb
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyAdv(i)._PorAdverb
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyAdv(i)._GreAdverb
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyAdv(i)._RusAdverb
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyAdv(i)._PolAdverb
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyAdv(i)._AnyAdverb
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyAdv(i)._KonAdverb
                synString = pubVocabularyAdv(i)._SynAdverb
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Adverb"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Adjektive
        For i = 1 To countVocAdjective
            nivString = pubVocabularyAdj(i)._NivAdjective
            thmString = Val(pubVocabularyAdj(i)._ThmAdjective).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyAdj(i)._EspAdjective
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyAdj(i)._GerAdjective
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyAdj(i)._EngAdjective
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyAdj(i)._FraAdjective
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyAdj(i)._SpaAdjective
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyAdj(i)._ItaAdjective
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyAdj(i)._DanAdjective
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyAdj(i)._PorAdjective
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyAdj(i)._GreAdjective
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyAdj(i)._RusAdjective
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyAdj(i)._PolAdjective
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyAdj(i)._AnyAdjective
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyAdj(i)._KonAdjective
                synString = pubVocabularyAdj(i)._SynAdjective
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Adjektive"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Preapositionen
        For i = 1 To countVocPreposition
            nivString = pubVocabularyPre(i)._NivPreposition
            thmString = Val(pubVocabularyPre(i)._ThmPreposition).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyPre(i)._EspPreposition
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyPre(i)._GerPreposition
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyPre(i)._EngPreposition
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyPre(i)._FraPreposition
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyPre(i)._SpaPreposition
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyPre(i)._ItaPreposition
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyPre(i)._DanPreposition
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyPre(i)._PorPreposition
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyPre(i)._GrePreposition
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyPre(i)._RusPreposition
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyPre(i)._PolPreposition
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyPre(i)._AnyPreposition
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyPre(i)._KonPreposition
                synString = pubVocabularyPre(i)._SynPreposition
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Preposition"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Partikel
        For i = 1 To countVocParticle
            nivString = pubVocabularyPar(i)._NivParticle
            thmString = Val(pubVocabularyPar(i)._ThmParticle).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyPar(i)._EspParticle
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyPar(i)._GerParticle
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyPar(i)._EngParticle
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyPar(i)._FraParticle
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyPar(i)._SpaParticle
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyPar(i)._ItaParticle
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyPar(i)._DanParticle
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyPar(i)._PorParticle
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyPar(i)._GreParticle
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyPar(i)._RusParticle
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyPar(i)._PolParticle
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyPar(i)._AnyParticle
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyPar(i)._KonParticle
                synString = pubVocabularyPar(i)._SynParticle
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Particle"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next

        ' Konjunktionen
        For i = 1 To countVocJunction
            nivString = pubVocabularyJun(i)._NivJunction
            thmString = Val(pubVocabularyJun(i)._ThmJunction).ToString

            If ((frmDictionary.RadioButtonNiveau.Checked = True And nivString = selString) Or _
                (frmDictionary.RadioButtonTheme.Checked = True And thmString = selString)) Then
                ' From and to Word
                fromString = ""
                toString = ""
                tmpString = ""
                For j = 1 To 2
                    If (languages(j) = LangName.Esperanto) Then tmpString = pubVocabularyJun(i)._EspJunction
                    If (languages(j) = LangName.Deutsch) Then tmpString = pubVocabularyJun(i)._GerJunction
                    If (languages(j) = LangName.English) Then tmpString = pubVocabularyJun(i)._EngJunction
                    If (languages(j) = LangName.Francais) Then tmpString = pubVocabularyJun(i)._FraJunction
                    If (languages(j) = LangName.Espanol) Then tmpString = pubVocabularyJun(i)._SpaJunction
                    If (languages(j) = LangName.Italiano) Then tmpString = pubVocabularyJun(i)._ItaJunction
                    If (languages(j) = LangName.Dansk) Then tmpString = pubVocabularyJun(i)._DanJunction
                    If (languages(j) = LangName.Portoguese) Then tmpString = pubVocabularyJun(i)._PorJunction
                    If (languages(j) = LangName.Ellenika) Then tmpString = pubVocabularyJun(i)._GreJunction
                    If (languages(j) = LangName.Russkij) Then tmpString = pubVocabularyJun(i)._RusJunction
                    If (languages(j) = LangName.Polski) Then tmpString = pubVocabularyJun(i)._PolJunction
                    If (languages(j) = LangName.AnyLang) Then tmpString = pubVocabularyJun(i)._AnyJunction
                    If (j = 1) Then
                        fromString = tmpString
                    ElseIf (j = 2) Then
                        toString = tmpString
                    End If
                Next
                conString = pubVocabularyJun(i)._KonJunction
                synString = pubVocabularyJun(i)._SynJunction
                ' Leereintraege abweisen
                If (fromString <> "***" And fromString <> "###" And fromString <> "" And toString <> "***" And toString <> "###" And toString <> "") Then
                    ' Word Counter
                    wordlstcount = wordlstcount + 1
                    ' Daten erfassen
                    tmpWordListEle._wordListFrom = fromString
                    tmpWordListEle._wordListTo = toString
                    tmpWordListEle._wordListCon = conString
                    tmpWordListEle._wordListSyn = synString
                    tmpWordListEle._wordListType = "Junction"
                    If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                        tmpWordListEle._wordListSort = pubVocThemes(Val(thmString))
                    ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                        tmpWordListEle._wordListSort = nivString
                    End If
                    ' Hinzufuegen
                    wordListVoc.Add(tmpWordListEle)
                    ' neu Initialisieren
                    tmpWordListEle = Nothing
                    tmpWordListEle = New WordListElement
                End If
            End If

        Next


        ' Sorting by Theme / Niveau
        wordListVoc.Sort()


        ' aktuelles Datum
        Datum = System.DateTime.Today.Date
        strDatum = Datum.Day & "." & Datum.Month & "." & Datum.Year

        ' aktuelle Uhrzeit
        Zeit = Now()
        strZeit = Format(Zeit.Hour, "00") & ":" & Format(Zeit.Minute, "00") & ":" & Format(Zeit.Second, "00")

        ' Open File
        Using sw As System.IO.StreamWriter = New System.IO.StreamWriter(vocListFile, False, System.Text.Encoding.Unicode)

            ' Generate Vocabular List as HTML Tab
            sw.WriteLine("<!-- created by Decaleon at " & strDatum & " at " & strZeit & " -->")
            sw.WriteLine("<html>")
            sw.WriteLine("<head>")
            sw.WriteLine("<title>Vocabulary List " & pubLanguage(fromLanguage) & "-" & pubLanguage(toLanguage) & "</title>")
            sw.WriteLine("</head>")
            sw.WriteLine("<body>")
            If (frmDictionary.RadioButtonNiveau.Checked = True) Then
                sw.WriteLine("<H1>Selection: Niveau " & selString & "</H1>")
            ElseIf (frmDictionary.RadioButtonTheme.Checked = True) Then
                sw.WriteLine("<H1>Selection: Theme " & pubVocThemes(Val(selString)) & "</H1>")
            End If
            ' Start Table
            sw.WriteLine("<table border='1'>")
            sw.WriteLine("<th>No.</th><th>Sort</th><th>" & pubLanguage(fromLanguage) & "</th><th>" & pubLanguage(toLanguage) & "</th><th>Context/Synonym</th><th>Word Type</th>")
            sw.WriteLine("<tr>")
            sw.WriteLine("<th></th><th></th><th></th><th></th><th></th><th></th>")
            sw.WriteLine("</tr>")
            ' Words
            For i = 1 To wordlstcount
                sw.WriteLine("<tr>")
                sw.WriteLine("<th>" & i.ToString & _
                    "</th><th>" & wordListVoc.Item(i - 1)._wordListSort & _
                    "</th><th>" & wordListVoc.Item(i - 1)._wordListFrom & _
                    "</th><th>" & wordListVoc.Item(i - 1)._wordListTo & _
                    "</th><th>" & wordListVoc.Item(i - 1)._wordListCon & " / " & wordListVoc.Item(i - 1)._wordListSyn & _
                    "</th><th>" & wordListVoc.Item(i - 1)._wordListType & _
                    "</th>")
                sw.WriteLine("</tr>")
            Next
            ' End Table
            sw.WriteLine("</table>")
            sw.WriteLine("<P>")
            sw.WriteLine("</P>")
            sw.WriteLine("<BR>")
            sw.WriteLine("<BR>")
            sw.WriteLine("</body>")
            sw.WriteLine("</html>")

            ' Close File
            sw.Close()
        End Using

        ' Message
        MsgBox("List " & vocListFile & " generated and saved into /bin/Debug Directory!", MsgBoxStyle.Information, "finished")

    End Sub

    Private Sub ComboBoxSortChoice_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxSortChoice.SelectedIndexChanged
        ' Set Focus
        ButtonList.Focus()

    End Sub

End Class